git: f6d448caf698 - stable/13 - pf tests: ftp-proxy test

Kristof Provost kp at FreeBSD.org
Thu Jul 8 11:50:33 UTC 2021


The branch stable/13 has been updated by kp:

URL: https://cgit.FreeBSD.org/src/commit/?id=f6d448caf69889eca9e41a0815db65a22fe7652d

commit f6d448caf69889eca9e41a0815db65a22fe7652d
Author:     Kristof Provost <kp at FreeBSD.org>
AuthorDate: 2021-07-01 15:15:36 +0000
Commit:     Kristof Provost <kp at FreeBSD.org>
CommitDate: 2021-07-08 06:47:09 +0000

    pf tests: ftp-proxy test
    
    Basic test case for ftp-proxy
    
    PR:             256917
    MFC after:      1 week
    Sponsored by:   Rubicon Communications, LLC ("Netgate")
    
    (cherry picked from commit dd82fd3543022017b84007ac1a0d45fc683f9850)
---
 tests/sys/netpfil/pf/Makefile |  1 +
 tests/sys/netpfil/pf/proxy.sh | 95 +++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 96 insertions(+)

diff --git a/tests/sys/netpfil/pf/Makefile b/tests/sys/netpfil/pf/Makefile
index e21f78e761b6..b693ca63adcb 100644
--- a/tests/sys/netpfil/pf/Makefile
+++ b/tests/sys/netpfil/pf/Makefile
@@ -17,6 +17,7 @@ ATF_TESTS_SH+=	anchor \
 		nat \
 		pass_block \
 		pfsync	\
+		proxy \
 		rdr \
 		route_to \
 		rules_counter \
diff --git a/tests/sys/netpfil/pf/proxy.sh b/tests/sys/netpfil/pf/proxy.sh
new file mode 100644
index 000000000000..bb5286103e85
--- /dev/null
+++ b/tests/sys/netpfil/pf/proxy.sh
@@ -0,0 +1,95 @@
+# $FreeBSD$
+#
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
+# Copyright (c) 2021 Rubicon Communications, LLC (Netgate)
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+. $(atf_get_srcdir)/utils.subr
+
+common_dir=$(atf_get_srcdir)/../common
+
+atf_test_case "ftp" "cleanup"
+ftp_head()
+{
+	atf_set descr 'Test ftp-proxy'
+	atf_set require.user root
+	atf_set require.progs twistd
+}
+
+ftp_body()
+{
+	pft_init
+
+	epair_client=$(vnet_mkepair)
+	epair_link=$(vnet_mkepair)
+
+	ifconfig ${epair_client}a 192.0.2.2/24 up
+	route add -net 198.51.100.0/24 192.0.2.1
+
+	vnet_mkjail fwd ${epair_client}b ${epair_link}a
+	jexec fwd ifconfig ${epair_client}b 192.0.2.1/24 up
+	jexec fwd ifconfig ${epair_link}a 198.51.100.1/24 up
+	jexec fwd ifconfig lo0 127.0.0.1/8 up
+	jexec fwd sysctl net.inet.ip.forwarding=1
+
+	vnet_mkjail srv ${epair_link}b
+	jexec srv ifconfig ${epair_link}b 198.51.100.2/24 up
+	jexec srv route add default 198.51.100.1
+
+	# Start FTP server in srv
+	jexec srv twistd ftp -r `pwd` -p 21
+
+	# Sanity check
+	atf_check -s exit:0 -o ignore ping -c 1 198.51.100.2
+
+	jexec fwd pfctl -e
+	pft_set_rules fwd \
+		"nat on ${epair_link}a inet from 192.0.2.0/24 to any -> (${epair_link}a)" \
+		"nat-anchor \"ftp-proxy/*\"" \
+		"rdr-anchor \"ftp-proxy/*\"" \
+		"rdr pass on ${epair_client}b proto tcp from 192.0.2.0/24 to any port 21 -> 127.0.0.1 port 8021" \
+		"anchor \"ftp-proxy/*\"" \
+		"pass out proto tcp from 127.0.0.1 to any port 21"
+	jexec fwd /usr/sbin/ftp-proxy
+
+	# Create a dummy file to download
+	echo 'foo' > remote.txt
+	echo 'get remote.txt local.txt' | ftp -a 198.51.100.2
+
+	# Compare the downloaded file to the original
+	if ! diff -q local.txt remote.txt;
+	then
+		atf_fail 'Failed to retrieve file'
+	fi
+}
+
+ftp_cleanup()
+{
+	pft_cleanup
+}
+
+atf_init_test_cases()
+{
+	atf_add_test_case "ftp"
+}


More information about the dev-commits-src-all mailing list